/*  COMMAND HELP:                                                    */
/*                                                                   */
/*     (1)  Gets HELP on all OS commands, puts it into an array.     */
/*     (2)  Lets user get HELP info from the array or the OS.        */

trace off                   /* ignore HELP command return code of '1'*/

cmd_text_out. = ''          /* array to read HELP output into        */
cmd_help.     = ''          /* array to build with command HELP info */

address SYSTEM 'help' WITH OUTPUT STEM cmd_text_out. 

/* read contents of CMD_TEXT_OUT, build help array CMD_HELP          */

do j=1 to cmd_text_out.0
   parse var cmd_text_out.j  the_command  command_desc
   cmd_help.the_command = command_desc
end

/* allow user to query CMD_HELP array & issue full HELP commands     */

call charout ,"Enter Command you want Help on, or QUIT: " 
pull cmd_in .  
do while cmd_in <> 'QUIT'
   if cmd_help.cmd_in = '' then
       say cmd_in  '   No help available.'
   else do
      say cmd_in cmd_help.cmd_in
      call charout ,"Want detailed information? "
      pull answer .
      if answer = 'Y' | answer = 'YES' then
         address SYSTEM 'help' cmd_in
   end

   call charout ,"Enter Command you want Help on, or QUIT: "  
   pull cmd_in .  
end
