/*   Simple "test driver" for the REVERSE function.                  */     

parse arg string .
call reverse string                   /* call the REVERSE function   */
say 'The reversed string is:' result  /* display the RESULT          */
exit 0                


/*  REVERSE:                                                         */
/*                                                                   */
/*     Recursive routine that reverses the characters in a string.   */

reverse: procedure

parse arg string        /* read the string to reverse                */

if string == ''         /* here's the 'end recursion' condition      */
   then return ''
else
   return substr(string,length(string),1) || , 
          reverse(substr(string,1,length(string)-1)) 
       