/* REXX TRY1                                                    */
/*                                                              */
/*    Reads user-input Rexx statements and interprets them.     */

say "Type: 'exit' to end this program"

start_loop: 
   signal on syntax                   /* establish error trap   */

   do forever
      call charout ,"==> "            /* prompt/read on 1 line  */
      parse pull expression$           
      interpret expression$           /* INTERPRET user's input */
   end

end_start_loop:  exit 0

SYNTAX:
    say 'SYNTAX:' errortext(rc) '(error' rc')'    /* write error*/
    signal start_loop                 /* return to processing   */
