/***************************************************************/
/* TAKIN' CHANCES                                              */
/*                                                             */
/* Illustrates Reginald's ability to work with the Registry.   */
/*                                                             */
/* CAUTION- Backup Registry before running this program!       */
/***************************************************************/

/* create a directory and a sub-directory to it                */

fd = value("My Dir\",            , "WIN32")
fd = value("My Dir\My Sub-Dir\", , "WIN32")


/* create and display a file within that sub-directory         */


fd = value("My Dir\My Sub-Dir\My File","TEST DATA ONLY","WIN32")

say 'Registry data:' value("My Dir\My Sub-Dir\My File", , "WIN32")

say 'Press <ENTER> to continue...' ; pull .


/* delete the registry file and prove that it is gone          */

fd = value("", "My Dir\My Sub-Dir\My File", "WIN32")

if value("My Dir\My Sub-Dir\", "My File", "WIN32") == 1
   then say 'Registry file exists'
   else say 'Registry file has been deleted'


/* delete the directory and sub-directory we created           */

fd = value("", "My Dir\My Sub-Dir\", "WIN32")
fd = value("", "My Dir\",            "WIN32")

say 'Registry directory and sub-directory have been deleted'
say 'Press <ENTER> to exit...' ; pull .
exit 0